#ifndef MATHLIB_BOX_H
#define MATHLIB_BOX_H

#include <mathlib/matrix.h>

namespace mathlib {

// axis aligned bounding box
template<int D>
class box {
public:
	vector<D> min;
	vector<D> max;

	box() {}
	box(const vector<D> &min_, const vector<D> &max_)
		: min(min_), max(max_) {}

	box &operator|=(const vector<D> &v) {
		for (int i=0; i!=D; ++i)
			if (v(i) < min(i))
				min(i) = v(i);
			else if (v(i) > max(i))
				max(i) = v(i);
		return *this;
	}
};

template<int D> inline
box<D> operator|(const box<D> &b, const vector<D> &v) {
	box<D> r = b;
	return r |= v;
}

} // namespace mathlib

#endif
