#include <mathlib/matrix.tpp>

namespace mathlib {

typedef basic_matrix<2, 2> m2;

void matrix_assign_handler::go(m2 &dest, matrix_unop<unop_inverse, m2> src)
{
	float det_src = det_bm(src.a);
	float d = 1.f / det_src;

	// dest = adjoint(src.a) / det(src.a)
	dest(0,0) = d * +src.a(1,1);
	dest(1,0) = d * -src.a(1,0);

	dest(0,1) = d * -src.a(0,1);
	dest(1,1) = d * +src.a(0,0);
}

} // namespace mathlib
