#include <mathlib/quaternion.h>

namespace mathlib {

quaternion operator*(const quaternion &a, const quaternion &b) {
	quaternion r;
	r.a = a.a*b.a - a.b*b.b - a.c*b.c - a.d*b.d;
	r.b = a.a*b.b + a.b*b.a + a.c*b.d - a.d*b.c;
	r.c = a.a*b.c - a.b*b.d + a.c*b.a + a.d*b.b;
	r.d = a.a*b.d + a.b*b.c - a.c*b.b + a.d*b.a;
	return r;
}

quaternion operator/(const quaternion &a, const quaternion &b) {
	quaternion r;
	float d = abs(b);
	r.a = (+a.a*b.a + a.b*b.b + a.c*b.c + a.d*b.d) / d;
	r.b = (-a.a*b.b + a.b*b.a - a.c*b.d + a.d*b.c) / d;
	r.c = (-a.a*b.c + a.b*b.d + a.c*b.a - a.d*b.b) / d;
	r.d = (-a.a*b.d - a.b*b.c + a.c*b.b + a.d*b.a) / d;
	return r;
}

} // namespace mathlib
